Package: RcppAnnoy
Type: Package
Title: 'Rcpp' Bindings for 'Annoy', a Library for Approximate Nearest
        Neighbors
Version: 0.0.23
Date: 2026-01-12
Authors@R: c(person("Dirk", "Eddelbuettel", role = c("aut", "cre"), email = "edd@debian.org",
                    comment = c(ORCID = "0000-0001-6419-907X")),
             person("Erik", "Bernhardsson", role = c("aut"),
                    comment = "Principal author of Annoy"))
Description: 'Annoy' is a small C++ library for Approximate Nearest Neighbors 
 written for efficient memory usage as well an ability to load from / save to
 disk. This package provides an R interface by relying on the 'Rcpp' package,
 exposing the same interface as the original Python wrapper to 'Annoy'. See
 <https://github.com/spotify/annoy> for more on 'Annoy'. 'Annoy' is released
 under Version 2.0 of the Apache License. Also included is a small Windows
 port of 'mmap' which is released under the MIT license.
License: GPL (>= 2)
Depends: R (>= 3.1)
Imports: methods, Rcpp
LinkingTo: Rcpp
Suggests: tinytest
URL: https://github.com/eddelbuettel/rcppannoy,
        https://dirk.eddelbuettel.com/code/rcpp.annoy.html
BugReports: https://github.com/eddelbuettel/rcppannoy/issues
NeedsCompilation: yes
RoxygenNote: 7.3.2
Encoding: UTF-8
VignetteBuilder: Rcpp
Packaged: 2026-01-12 12:24:51 UTC; edd
Author: Dirk Eddelbuettel [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6419-907X>),
  Erik Bernhardsson [aut] (Principal author of Annoy)
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Repository: CRAN
Date/Publication: 2026-01-12 13:10:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 16:22:52 UTC; unix
Archs: RcppAnnoy.so.dSYM

Package: RcppAnnoy
Type: Package
Title: 'Rcpp' Bindings for 'Annoy', a Library for Approximate Nearest
        Neighbors
Version: 0.0.23
Date: 2026-01-12
Authors@R: c(person("Dirk", "Eddelbuettel", role = c("aut", "cre"), email = "edd@debian.org",
                    comment = c(ORCID = "0000-0001-6419-907X")),
             person("Erik", "Bernhardsson", role = c("aut"),
                    comment = "Principal author of Annoy"))
Description: 'Annoy' is a small C++ library for Approximate Nearest Neighbors 
 written for efficient memory usage as well an ability to load from / save to
 disk. This package provides an R interface by relying on the 'Rcpp' package,
 exposing the same interface as the original Python wrapper to 'Annoy'. See
 <https://github.com/spotify/annoy> for more on 'Annoy'. 'Annoy' is released
 under Version 2.0 of the Apache License. Also included is a small Windows
 port of 'mmap' which is released under the MIT license.
License: GPL (>= 2)
Depends: R (>= 3.1)
Imports: methods, Rcpp
LinkingTo: Rcpp
Suggests: tinytest
URL: https://github.com/eddelbuettel/rcppannoy,
        https://dirk.eddelbuettel.com/code/rcpp.annoy.html
BugReports: https://github.com/eddelbuettel/rcppannoy/issues
NeedsCompilation: yes
RoxygenNote: 7.3.2
Encoding: UTF-8
VignetteBuilder: Rcpp
Packaged: 2026-01-12 12:24:51 UTC; edd
Author: Dirk Eddelbuettel [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6419-907X>),
  Erik Bernhardsson [aut] (Principal author of Annoy)
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Repository: CRAN
Date/Publication: 2026-01-12 13:10:02 UTC

## RcppAnnoy: Rcpp bindings for [Annoy](https://github.com/spotify/annoy)

[![CI](https://github.com/eddelbuettel/rcppannoy/workflows/ci/badge.svg)](https://github.com/eddelbuettel/rcppannoy/actions?query=workflow%3Aci)
[![License](https://eddelbuettel.github.io/badges/GPL2+.svg)](https://www.r-project.org/Licenses/GPL-2)
[![CRAN](https://www.r-pkg.org/badges/version/RcppAnnoy)](https://cran.r-project.org/package=RcppAnnoy)
[![r-universe](https://eddelbuettel.r-universe.dev/badges/RcppAnnoy)](https://eddelbuettel.r-universe.dev/RcppAnnoy)
[![Dependencies](https://tinyverse.netlify.app/badge/RcppAnnoy)](https://cran.r-project.org/package=RcppAnnoy)
[![Downloads](https://cranlogs.r-pkg.org/badges/RcppAnnoy?color=brightgreen)](https://www.r-pkg.org:443/pkg/RcppAnnoy)
[![Last Commit](https://img.shields.io/github/last-commit/eddelbuettel/rcppannoy)](https://github.com/eddelbuettel/rcppannoy)

### What is Annoy?

[Annoy](https://github.com/spotify/annoy) is a small, fast and lightweight library for
Approximate Nearest Neighbours with a particular focus on efficient memory use and the
ability to load a pre-saved index.

[Annoy](https://github.com/spotify/annoy) is written by [Erik
Bernhardsson](https://erikbern.com/). See its page for more on features, its (Python) API,
and the other language ports. [Annoy](https://github.com/spotify/annoy) is part of the
esteemed _let us find other music you may like_ algorithm by
[Spotify](https://github.com/spotify/). 

### Why this package?

It provides a nice example for Rcpp Modules and use of templates: Annoy uses
a clean C++ core with templated data type, as well as several distance
measures.  This package shows that it is easy to wrap both aspects from R giving us
multi-lingual approaches to data discovery and machine learning.

### Status

The package matches the behaviour of the original Python package in the
original Python wrapper for the [Annoy](https://github.com/spotify/annoy)
library. It also replicates all unit tests written for the Python frontend,
including a test for efficiently `mmap`-ing a binary index file.

The package originally built on Linux and OS X, and thanks to a patch by
[Qiang Kou](https://github.com/thirdwing) now also builds on Windows.

### Installation

You can either install from source via this repo, or install
[the CRAN package](https://cran.r-project.org/package=RcppAnnoy) the usual
way from [R](https://www.r-project.org).

### Author

Dirk Eddelbuettel

### License

GPL (>= 2)

## Suggested by @SamGG in https://github.com/eddelbuettel/rcppannoy/issues/79#issuecomment-2518597494

library(RcppAnnoy)

# IRIS EXAMPLE -----------------------------------------------------------------

data(iris)

# Converts to numeric, ignoring the species
X <- as.matrix(iris[,-5])

# BuildinG index
a <- new(AnnoyEuclidean, ncol(X))
a$setSeed(42)
# Load dataset into index; Annoy uses zero indexing
for (i in 1:nrow(X))
  a$addItem(i - 1, X[i,])
# Build forest with 20 trees
a$build(50)
# Reports about the forest
a$getNItems()
a$getNTrees()

# Performing search
k <- 5 # number of nearest neighbors
nn.index <- matrix(nrow = nrow(X), ncol = k)
for (i in 1:nrow(X))
  nn.index[i,] <- a$getNNsByVector(X[i,], k)
# Annoy uses zero indexing, so index must be incremented
nn.index = nn.index + 1
# The first match is the query itself most of the time
plot(1:nrow(X), nn.index[,1])
# Explore the second nearest neighbor
opar = par(mfrow = c(2, 2))
for (i in 1:ncol(X))
  plot(X[, i], X[nn.index[,2], i], xlab = colnames(X)[i], ylab = "nearest")
par(opar)

# Perform search with distance
k <- 5
nn.index <- matrix(nrow = nrow(X), ncol = k)
nn.distance <- matrix(nrow = nrow(X), ncol = k)
for (i in 1:nrow(X)) {
  res <- a$getNNsByVectorList(X[i,], k, -1, TRUE)
  nn.index[i,] <- res$item
  nn.distance[i,] <- res$distance
}
# Annoy uses zero indexing, so index must be incremented
nn.index = nn.index + 1
# Explore distance to the second nearest neighbor
hist(nn.distance[,2], xlab = "Distance to the 2nd NN",
     main = "Histogram of distance")

# Unload index from memory
a$unload()
rm(a)

## cf the simple example at https://github.com/spotify/annoy

library(RcppAnnoy)

set.seed(123)                           # be reproducible

f <- 40
a <- new(AnnoyEuclidean, f)
n <- 50                                 # not specified

for (i in seq(n)) {
    v <- rnorm(f)
    a$addItem(i-1, v)
}

a$build(50)                           	# 50 trees
a$save("/tmp/test.tree")


b <- new(AnnoyEuclidean, f)           	# new object, could be in another process
b$load("/tmp/test.tree")		# super fast, will just mmap the file

print(b$getNNsByItem(0, 40))

suppressMessages(library(RcppAnnoy))

## test01getNNsByVector
f <- 2
a <- new(AnnoyManhattan, f)
a$addItem(0, c(2, 2))
a$addItem(1, c(3, 2))
a$addItem(2, c(3, 3))
a$build(10)
checkEqual(a$getNNsByVector(c(4,4), 3), c(2,1,0), msg="getNNsByVector check 1")
checkEqual(a$getNNsByVector(c(1,1), 3), c(0,1,2), msg="getNNsByVector check 2")
checkEqual(a$getNNsByVector(c(5,3), 3), c(2,1,0), msg="getNNsByVector check 3")


## test02getNNsByItem
f <- 2
a <- new(AnnoyManhattan, f)
a$addItem(0, c(2, 2))
a$addItem(1, c(3, 2))
a$addItem(2, c(3, 3))
a$build(10)
checkEqual(a$getNNsByItem(0, 3), c(0, 1, 2), msg="getNNsByItem check 1")
checkEqual(a$getNNsByItem(2, 3), c(2, 1, 0), msg="getNNsByItem check 2")


## test03dist
f <- 2
a <- new(AnnoyManhattan, f)
a$addItem(0, c(0, 1))
a$addItem(1, c(1, 1))
a$addItem(2, c(0, 0))
checkEqual(a$getDistance(0, 1), 1.0, msg="distance 1")#
checkEqual(a$getDistance(1, 2), 2.0, msg="distance 2")#


## test04largeIndex
## Generate pairs of random points where the pair is super close
f <- 10
##q <- rnorm(f, 0, 10)
a <- new(AnnoyManhattan, f)
set.seed(123)
for (j in seq(0, 10000, by=2)) {
    p <- rnorm(f)
    x <- 1 + p + rnorm(f, 0, 1.0e-2)
    y <- 1 + p + rnorm(f, 0, 1.0e-2)
    a$addItem(j, x)
    a$addItem(j+1, y)
}
a$build(10)
res <- TRUE
for (j in seq(0, 10000, by=2)) {
    res <- res &&
        all.equal(a$getNNsByItem(j,   2), c(j,   j+1)) &&
        all.equal(a$getNNsByItem(j+1, 2), c(j+1, j))
}
checkTrue(res)


## test05precision
precision <- function(n, nTrees=10, nPoints=10000, nRounds=3) {
    found <- 0
    for (r in 1:nRounds) {
        ## create random points at distance x
        f <- 10
        a <- new(AnnoyManhattan, f)

        for (j in seq(nPoints)) {
            p <- rnorm(f, 0, 1)
            nrm <- sqrt(sum(p^2))
            x <- p / nrm + j
            a$addItem(j, x)
        }
        a$build(nTrees)

        nns <- a$getNNsByVector(rep(0, f), n)
        checkEqual(nns, nns[order(nns)], msg="checking precision order")  # should be in order
        ## The number of gaps should be equal to the last item minus n-1
        found <- found + length(nns[nns <= n])
    }
    return(1.0 * found / (n * nRounds))
}
checkTrue(precision(1)    >= 0.98) #, msg="precision at 1")
checkTrue(precision(10)   >= 0.98) #, msg="precision at 10")
checkTrue(precision(100)  >= 0.98) #, msg="precision at 100")
checkTrue(precision(1000) >= 0.98) #, msg="precision at 1000")

suppressMessages(library(RcppAnnoy))

# test01getNNsByVector
f <- 2
a <- new(AnnoyHamming, f)
a$addItem(0, c(2, 2))
a$addItem(1, c(3, 2))
a$addItem(2, c(3, 3))
a$build(10)
checkEqual(a$getNNsByVector(c(4,4), 3), c(0,1,2), msg="getNNsByVector check 1")
checkEqual(a$getNNsByVector(c(1,1), 3), c(2,1,0), msg="getNNsByVector check 2")
checkEqual(a$getNNsByVector(c(5,3), 3), c(2,1,0), msg="getNNsByVector check 3")


# test02getNNsByItem
f <- 2
a <- new(AnnoyHamming, f)
a$addItem(0, c(2, 2))
a$addItem(1, c(3, 2))
a$addItem(2, c(3, 3))
a$build(10)
checkEqual(a$getNNsByItem(0, 3), c(0, 1, 2), msg="getNNsByItem check 1")
checkEqual(a$getNNsByItem(2, 3), c(2, 1, 0), msg="getNNsByItem check 2")


# test03dist
f <- 2
a <- new(AnnoyHamming, f)
a$addItem(0, c(0, 1))
a$addItem(1, c(1, 1))
a$addItem(2, c(0, 0))
checkEqual(a$getDistance(0, 1), 1.0, msg="distance 1")#
checkEqual(a$getDistance(1, 2), 2.0, msg="distance 2")#


## test04largeIndex <- function() {
##     ## Generate pairs of random points where the pair is super close
##     f <- 10
##     #q <- rnorm(f, 0, 10)
##     a <- new(AnnoyHamming, f)
##     set.seed(123)
##     for (j in seq(0, 10000, by=2)) {
##         p <- rnorm(f)
##         x <- 1 + p + rnorm(f, 0, 1.0e-2)
##         y <- 1 + p + rnorm(f, 0, 1.0e-2)
##         a$addItem(j, x)
##         a$addItem(j+1, y)
##     }
##     a$build(10)
##     for (j in seq(0, 10000, by=2)) {
##         checkEquals(a$getNNsByItem(j,   2), c(j,   j+1), msg="getNNsByItem check 1")
##         checkEquals(a$getNNsByItem(j+1, 2), c(j+1, j),   msg="getNNsByItem check 2")
##     }
## }

## test05precision <- function() {

##     precision <- function(n, nTrees=10, nPoints=10000, nRounds=3) {
##         found <- 0
##         for (r in 1:nRounds) {
##             ## create random points at distance x
##             f <- 10
##             a <- new(AnnoyHamming, f)

##             for (j in seq(nPoints)) {
##                 p <- rnorm(f, 0, 1)
##                 nrm <- sqrt(sum(p^2))
##                 x <- p / nrm + j
##                 a$addItem(j, x)
##             }
##             a$build(nTrees)

##             nns <- a$getNNsByVector(rep(0, f), n)
##             checkEquals(nns, nns[order(nns)], msg="checking precision order")  # should be in order
##             ## The number of gaps should be equal to the last item minus n-1
##             found <- found + length(nns[nns <= n])
##         }
##         return(1.0 * found / (n * nRounds))
##     }

##     checkTrue(precision(1)    >= 0.98, msg="precision at 1")
##     checkTrue(precision(10)   >= 0.98, msg="precision at 10")
##     checkTrue(precision(100)  >= 0.98, msg="precision at 100")
##     checkTrue(precision(1000) >= 0.98, msg="precision at 1000")

## }

suppressMessages(library(RcppAnnoy))

## getNNsByVector
f <- 2
a <- new(AnnoyEuclidean, f)
a$addItem(0, c(2, 2))
a$addItem(1, c(3, 2))
a$addItem(2, c(3, 3))
a$build(10)
checkEqual(a$getNNsByVector(c(4,4), 3), c(2,1,0), msg="getNNsByVector check 1")
checkEqual(a$getNNsByVector(c(1,1), 3), c(0,1,2), msg="getNNsByVector check 1")
checkEqual(a$getNNsByVector(c(4,2), 3), c(1,2,0), msg="getNNsByVector check 1")


## getNNsByItem
f <- 2
a <- new(AnnoyEuclidean, f)
a$addItem(0, c(2, 2))
a$addItem(1, c(3, 2))
a$addItem(2, c(3, 3))
a$build(10)
checkEqual(a$getNNsByItem(0, 3), c(0, 1, 2), msg="getNNsByItem check 1")
checkEqual(a$getNNsByItem(2, 3), c(2, 1, 0), msg="getNNsByItem check 2")


### test03dist
f <- 2
a <- new(AnnoyEuclidean, f)
a$addItem(0, c(0, 1))
a$addItem(1, c(1, 1))
a$addItem(2, c(0, 0))
checkEqual(a$getDistance(0, 1), 1.0^0.5, msg="distance 1")
checkEqual(a$getDistance(1, 2), 2.0^0.5, msg="distance 2", tolerance=1e-6)



## test04largeIndex
## Generate pairs of random points where the pair is super close
f <- 10
#q <- rnorm(f, 0, 10)
a <- new(AnnoyEuclidean, f)
set.seed(123)
for (j in seq(0, 10000, by=2)) {
    p <- rnorm(f)
    x <- 1 + p + rnorm(f, 0, 1.0e-2)
    y <- 1 + p + rnorm(f, 0, 1.0e-2)
    a$addItem(j, x)
    a$addItem(j+1, y)
}
a$build(10)
res <- TRUE
for (j in seq(0, 10000, by=2)) {
    #expect_equal(a$getNNsByItem(j,   2), c(j,   j+1), msg="getNNsByItem check1")
    #expect_equal(a$getNNsByItem(j+1, 2), c(j+1, j),   msg="getNNsByItem check1")
    res <- res &&
        all.equal(a$getNNsByItem(j,   2), c(j,   j+1)) &&
        all.equal(a$getNNsByItem(j+1, 2), c(j+1, j))
}
expect_true(res)



## test05precision
precision <- function(n, nTrees=10, nPoints=10000, nRounds=3) {
    found <- 0
    for (r in 1:nRounds) {
        ## create random points at distance x
        f <- 10
        a <- new(AnnoyEuclidean, f)

        for (j in seq(nPoints)) {
            p <- rnorm(f, 0, 1)
            nrm <- sqrt(sum(p^2))
            x <- p / nrm * j
            a$addItem(j, x)
        }
        a$build(nTrees)

        nns <- a$getNNsByVector(rep(0, f), n)
        checkEqual(nns, nns[order(nns)], msg="checking precision order")  # should be in order
        ## The number of gaps should be equal to the last item minus n-1
        found <- found + length(nns[ nns <= n])
    }
    return(1.0 * found / (n * nRounds))
}

checkTrue(precision(1)    >= 0.98)#, msg="precision at 1")
checkTrue(precision(10)   >= 0.98)#, msg="precision at 10")
checkTrue(precision(100)  >= 0.98)#, msg="precision at 100")
checkTrue(precision(1000) >= 0.98)#, msg="precision at 1000")

## if this is set (eg .travis.yml) then run the test
if (Sys.getenv("RunAllRcppAnnoyTests") != "yes") exit_file("Skip this test")

suppressMessages(library(RcppAnnoy))

f <- 2

set.seed(123456)   # R Seed for next two vectors
n <- 100
x <- rnorm(n)
y <- rnorm(n)

v1 <- new(AnnoyHamming, f)
v1$setSeed(123)
for (i in 1:n) v1$addItem(i-1, c(x[i], y[i]))
v1$build(f)

v2 <- new(AnnoyHamming, f)
v2$setSeed(456)  # different
for (i in 1:n) v2$addItem(i-1, c(x[i], y[i]))
v2$build(f)

v3 <- new(AnnoyHamming, f)
v3$setSeed(123)  # as first
for (i in 1:n) v3$addItem(i-1, c(x[i], y[i]))
v3$build(f)

checkEqual(v1$getNNsByVector(c(0.5,0.5), 20),
           v3$getNNsByVector(c(0.5,0.5), 20)) # msg="v1 and v3 are equal")
checkTrue(any(v1$getNNsByVector(c(0.5,0.5), 20) !=
              v2$getNNsByVector(c(0.5,0.5), 20))) # msg="v1 and v2 are not equal")

#' @name AnnoyIndex
#'
#' @aliases
#' AnnoyEuclidean  Rcpp_AnnoyEuclidean-class  Rcpp_AnnoyEuclidean
#' AnnoyAngular    Rcpp_AnnoyAngular-class    Rcpp_AnnoyAngular
#' AnnoyManhattan  Rcpp_AnnoyManhattan-class  Rcpp_AnnoyManhattan
#' AnnoyHamming    Rcpp_AnnoyHamming-class    Rcpp_AnnoyHamming
#' AnnoyDotProduct Rcpp_AnnoyDotProduct-class Rcpp_AnnoyDotProduct
#'
#' @title Approximate Nearest Neighbors with Annoy
#'
#' @description
#' Annoy is a small library written to provide fast and memory-efficient
#' nearest neighbor lookup from a possibly static index which can be
#' shared across processes.
#'
#' @section Usage:
#' \preformatted{
#' a <- new(AnnoyEuclidean, vectorsz)
#'
#' a$setSeed(0)
#' a$setVerbose(0)
#'
#' a$addItem(i, dv)
#'
#' a$getNItems()
#'
#' a$getItemsVector(i)
#' a$getDistance(i, j)
#'
#' a$build(n_trees)
#'
#' a$getNNsByItem(i, n)
#' a$getNNsByItemList(i, n, search_k, include_distances)
#'
#' a$getNNsByVector(v, n)
#' a$getNNsByVectorList(v, n, search_k, include_distances)
#'
#' a$save(fn)
#' a$load(fn)
#' a$unload()
#' }
#'
#' @section Details:
#'
#' \code{new(Class, vectorsz)}
#' Create a new Annoy instance of type \code{Class} where \code{Class}
#' is on of the following:
#' \code{AnnoyEuclidean},
#' \code{AnnoyAngular},
#' \code{AnnoyManhattan},
#' \code{AnnoyHamming}.
#' \code{vectorsz} denotes the length of the vectors that the Annoy instance
#' will be indexing.
#'
#' \code{$addItem(i, v)}
#' Adds item \code{i} (any nonnegative integer) with vector \code{v}.
#' Note that it will allocate memory for \code{max(i) + 1} items.
#'
#' \code{$build(n_trees)}
#' Builds a forest of \code{n_trees} trees.
#' More trees gives higher precision when querying.
#' After calling \code{build}, no more items can be added.
#'
#' \code{$save(fn)}
#' Saves the index to disk as filename \code{fn}.
#' After saving, no more items can be added.
#'
#' \code{$load(fn)}
#' Loads (mmaps) an index from filename \code{fn} on disk.
#'
#' \code{$unload()}
#' Unloads index.
#'
#' \code{$getDistance(i, j)}
#' Returns the distance between items \code{i} and \code{j}
#'
#' \code{$getNNsByItem(i, n)}
#' Returns the \code{n} closest items as an integer vector of indices.
#'
#' \code{$getNNsByVector(v, n)}
#' Same as \code{$getNNsByItem}, but queries by vector \code{v} rather than
#' index \code{i}.
#'
#' \code{$getNNsByItemList(i, n, search_k = -1, include_distances = FALSE)}
#' Returns the n closest items to item \code{i} as a list.
#' During the query it will inspect up to \code{search_k} nodes which
#' defaults to \code{n_trees * n} if not provided.
#' \code{search_k} gives you a run-time tradeoff between better accuracy and
#' speed.
#' If you set \code{include_distances} to \code{TRUE},
#' it will return a length 2 list with elements \code{"item"} &
#' \code{"distance"}.
#' The \code{"item"} element contains the \code{n} closest items as an integer
#' vector of indices.
#' The optional \code{"distance"} element contains the corresponding distances
#' to \code{"item"} as a numeric vector.
#'
#' \code{$getNNsByVectorList(i, n, search_k = -1, include_distances = FALSE)}
#' Same as \code{$getNNsByItemList}, but queries by vector \code{v} rather than
#' index \code{i}
#'
#' \code{$getItemsVector(i)}
#' Returns the vector for item \code{i} that was previously added.
#'
#' \code{$getNItems()}
#' Returns the number of items in the index.
#'
#' \code{$setVerbose()}
#' If \code{1} then messages will be printed during processing.
#' If \code{0} then messages will be suppressed during processing.
#'
#' \code{$setSeed()}
#' Set random seed for annoy (integer).
#'
#' @examples
#' library(RcppAnnoy)
#'
#' # BUILDING ANNOY INDEX ---------------------------------------------------------
#' vector_size <- 10
#' a <- new(AnnoyEuclidean, vector_size)
#'
#' a$setSeed(42)
#'
#' # Turn on verbose status messages (0 to turn off)
#' a$setVerbose(1)
#'
#' # Load 100 random vectors into index
#' for (i in 1:100) a$addItem(i - 1, runif(vector_size)) # Annoy uses zero indexing
#'
#' # Display number of items in index
#' a$getNItems()
#'
#' # Retrieve item at postition 0 in index
#' a$getItemsVector(0)
#'
#' # Calculate distance between items at postitions 0 & 1 in index
#' a$getDistance(0, 1)
#'
#' # Build forest with 50 trees
#' a$build(50)
#'
#'
#' # PERFORMING ANNOY SEARCH ------------------------------------------------------
#'
#' # Retrieve 5 nearest neighbors to item 0
#' # Returned as integer vector of indices
#' a$getNNsByItem(0, 5)
#'
#' # Retrieve 5 nearest neighbors to item 0
#' # search_k = -1 will invoke default search_k value of n_trees * n
#' # Return results as list with an element for distance
#' a$getNNsByItemList(0, 5, -1, TRUE)
#'
#' # Retrieve 5 nearest neighbors to item 0
#' # search_k = -1 will invoke default search_k value of n_trees * n
#' # Return results as list without an element for distance
#' a$getNNsByItemList(0, 5, -1, FALSE)
#'
#'
#' v <- runif(vector_size)
#' # Retrieve 5 nearest neighbors to vector v
#' # Returned as integer vector of indices
#' a$getNNsByVector(v, 5)
#'
#' # Retrieve 5 nearest neighbors to vector v
#' # search_k = -1 will invoke default search_k value of n_trees * n
#' # Return results as list with an element for distance
#' a$getNNsByVectorList(v, 5, -1, TRUE)
#'
#' # SAVING/LOADING ANNOY INDEX ---------------------------------------------------
#'
#' # Create a tempfile, replace with a local file to keep
#' treefile <- tempfile(pattern="annoy", fileext=".tree")
#'
#' # Save annoy tree to disk
#' a$save(treefile)
#'
#' # Load annoy tree from disk
#' a$load(treefile)
#'
#' # Unload index from memory
#' a$unload()
NULL

## ensure module gets loaded
loadModule("AnnoyAngular", TRUE)
loadModule("AnnoyEuclidean", TRUE)
loadModule("AnnoyManhattan", TRUE)
loadModule("AnnoyHamming", TRUE)
loadModule("AnnoyDotProduct", TRUE)

#' Get the Annoy library version
#'
#' Get the version of the Annoy C++ library that RcppAnnoy was compiled with.
#'
#' @param compact Logical scalar indicating whether a compact
#'   \code{\link{package_version}} should be returned.
#'
#' @return An integer vector containing the major, minor and patch version numbers;
#' or if \code{compact=TRUE}, a \code{\link{package_version}} object.
#'
#' @author Aaron Lun
getAnnoyVersion <- function(compact=FALSE) {
    v <- .annoy_version()
    if (compact) as.package_version(paste(unname(v), collapse = "."))
    else v
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Report CPU Architecture and Compiler
#'
#' @return A constant direct created at compile-time describing
#' the extent of AVX instructions (512 bit, 128 bit, or none)
#' and compiler use where currently recognised are MSC (unlikely
#' for R), GCC, Clang, or \sQuote{other}.
getArchictectureStatus <- function() {
    .Call(`_RcppAnnoy_getArchictectureStatus`)
}

.annoy_version <- function() {
    .Call(`_RcppAnnoy_annoy_version`)
}

if (requireNamespace("tinytest", quietly=TRUE)) {

    ## Set a seed to make the test deterministic
    set.seed(42)

    ## there are several more granular ways to test files in a
    ## tinytest directory, see its package vignette; tests can also
    ## run once the package is installed using the same command

    ## we need version 0.9.3 or later
    if (packageVersion("tinytest") >= "0.9.3") {
        tinytest::test_package("RcppAnnoy")
    }
}

## See #66 for the idea and discussion

vigfile <- system.file("rmd", "UsingAnnoyInCpp.Rmd", package="RcppAnnoy")
if (!file.exists(vigfile)) exit_file("No vignette source found. What's up with that?")

lines <- readLines(vigfile)
starts <- which(lines == "```{Rcpp, eval=FALSE}")
ends <- which(lines=="```")
ends <- ends[findInterval(starts, ends)+1]
code <- lines[unlist(mapply(seq, starts+1, ends-1))]
res <- Rcpp::sourceCpp(code=paste(code, collapse="\n")) # checks everything is compileable.

expect_equal(res$functions, "thingy")   # check we got a function compiled

set.seed(42)
mat <- matrix(runif(1000), 100)
Q <- matrix(runif(100), 10)
res <- thingy(mat, 1, 10, Q, tempfile())
expect_equal(res, 1)

suppressMessages(library(RcppAnnoy))

f <- 3
a <- new(AnnoyAngular, f)
a$addItem(0, c(0,0,1))
a$addItem(1, c(0,1,0))
a$addItem(2, c(1,0,0))
a$build(10)
checkEqual(a$getNNsByVector(c(3,2,1), 3), c(2,1,0), msg="getNNsByVector check 1")
checkEqual(a$getNNsByVector(c(1,2,3), 3), c(0,1,2), msg="getNNsByVector check 1")
checkEqual(a$getNNsByVector(c(2,0,1), 3), c(2,0,1), msg="getNNsByVector check 1")


f <- 3
a <- new(AnnoyAngular, f)
a$addItem(0, c(2,1,0))
a$addItem(1, c(1,2,0))
a$addItem(2, c(0,0,1))
a$build(10)
checkEqual(a$getNNsByItem(0, 3), c(0,1,2), msg="getNNsByItem check1")
checkEqual(a$getNNsByItem(1, 3), c(1,0,2), msg="getNNsByItem check2")


f <- 2
a <- new(AnnoyAngular, f)
a$addItem(0, c(0, 1))
a$addItem(1, c(1, 1))
checkEqual(a$getDistance(0, 1), (2.0 * (1.0 - 2^(-0.5)))^0.5, msg="distance 1", tolerance=1e-6)


f <- 2
a <- new(AnnoyAngular, f)
a$addItem(0, c(1000, 0))
a$addItem(1, c(10, 0))
checkEqual(a$getDistance(0, 1), 0, msg="distance 2")


f <- 2
a <- new(AnnoyAngular, f)
a$addItem(0, c(97, 0))
a$addItem(1, c(42, 42))
d <- ((1 - 2^(-0.5))^2 + (2^(-0.5))^2)^0.5
checkEqual(a$getDistance(0, 1), d, msg="distance 3", tolerance=1.0e-6)


f <- 2
a <- new(AnnoyAngular, f)
a$addItem(0, c(1, 0))
a$addItem(1, c(0, 0))

checkEqual(a$getDistance(0, 1), 2.0^0.5, msg="distance 4", tolerance=1.0e-6)


## Generate pairs of random points where the pair is super close
f <- 10
a <- new(AnnoyAngular, f)
set.seed(123)
for (j in seq(0, 10000, by=2)) {
    p <- rnorm(f)
    f1 <- runif(1) + 1
    f2 <- runif(1) + 1
    x <- f1 * p + rnorm(f, 0, 1.0e-2)
    y <- f2 * p + rnorm(f, 0, 1.0e-2)
    a$addItem(j, x)
    a$addItem(j+1, y)
}
a$build(10)
res <- TRUE
for (j in seq(0, 10000, by=2)) {
    #expect_equal(a$getNNsByItem(j,   2), c(j,   j+1), msg="getNNsByItem check1")
    #expect_equal(a$getNNsByItem(j+1, 2), c(j+1, j),   msg="getNNsByItem check1")
    res <- res &&
        all.equal(a$getNNsByItem(j,   2), c(j,   j+1)) &&
        all.equal(a$getNNsByItem(j+1, 2), c(j+1, j))
}
checkTrue(res)

suppressMessages(library(RcppAnnoy))

f <- 3
a <- new(AnnoyDotProduct, f)
a$addItem(0, c(0,0,1))
a$addItem(1, c(0,1,0))
a$addItem(2, c(1,0,0))
a$build(10)
checkEqual(a$getNNsByVector(c(3,2,1), 3), c(2,1,0), msg="getNNsByVector check 1")
checkEqual(a$getNNsByVector(c(1,2,3), 3), c(0,1,2), msg="getNNsByVector check 1")
checkEqual(a$getNNsByVector(c(2,0,1), 3), c(2,0,1), msg="getNNsByVector check 1")


f <- 3
a <- new(AnnoyDotProduct, f)
a$addItem(0, c(2,1,0))
a$addItem(1, c(1,2,0))
a$addItem(2, c(0,0,1))
a$build(10)
checkEqual(a$getNNsByItem(0, 3), c(0,1,2), msg="getNNsByItem check1")
checkEqual(a$getNNsByItem(1, 3), c(1,0,2), msg="getNNsByItem check2")


f <- 2
a <- new(AnnoyDotProduct, f)
a$addItem(0, c(0, 1))
a$addItem(1, c(1, 1))
checkEqual(a$getDistance(0, 1), 0 * 1 + 1 * 1, msg="distance 1", tolerance=1e-6)


f <- 2
a <- new(AnnoyDotProduct, f)
a$addItem(0, c(1000, 0))
a$addItem(1, c(10, 0))
checkEqual(a$getDistance(0, 1), 1000 * 10 + 0 * 0, msg="distance 2", tolerance=1e-6)


f <- 2
a <- new(AnnoyDotProduct, f)
a$addItem(0, c(97, 0))
a$addItem(1, c(42, 42))
d <- 97 * 42 + 0 * 42
checkEqual(a$getDistance(0, 1), d, msg="distance 3", tolerance=1.0e-6)


f <- 2
a <- new(AnnoyDotProduct, f)
a$addItem(0, c(1, 0))
a$addItem(1, c(0, 0))
checkEqual(a$getDistance(0, 1), 0, msg="distance 4", tolerance=1.0e-6)


## Generate pairs of random points where the pair is super close
f <- 10
a <- new(AnnoyDotProduct, f)
set.seed(123)
for (j in seq(0, 10000, by=2)) {
    p <- rnorm(f)
    f1 <- runif(1) + 1
    f2 <- runif(1) + 1
    x <- f1 * p + rnorm(f, 0, 1.0e-2)
    y <- f2 * p + rnorm(f, 0, 1.0e-2)
    a$addItem(j, x / norm(x, "2"))
    a$addItem(j+1, y/norm(y, "2"))
}
a$build(10)
res <- TRUE
for (j in seq(0, 10000, by=2)) {
    #expect_equal(a$getNNsByItem(j,   2), c(j,   j+1), msg="getNNsByItem check1")
    #expect_equal(a$getNNsByItem(j+1, 2), c(j+1, j),   msg="getNNsByItem check1")
    res <- res &&
        all.equal(a$getNNsByItem(j,   2), c(j,   j+1)) &&
        all.equal(a$getNNsByItem(j+1, 2), c(j+1, j))
}
checkTrue(res)

suppressMessages(library(RcppAnnoy))

f <- 2  # arbitrary
a <- new(AnnoyEuclidean, f)

diskfile <- tempfile(pattern="annoy", fileext="bin")
expect_true(a$onDiskBuild(diskfile))

a$addItem(0, c(2, 2))
a$addItem(1, c(3, 2))
a$addItem(2, c(3, 3))
a$build(10)

expect_equal(a$getNNsByVector(c(4,4), 3), c(2,1,0)) #, msg="getNNsByVector check 1")
expect_equal(a$getNNsByVector(c(1,1), 3), c(0,1,2)) #, msg="getNNsByVector check 2")
expect_equal(a$getNNsByVector(c(5,3), 3), c(2,1,0)) #, msg="getNNsByVector check 3")

a$unload()
a$load(diskfile)
expect_equal(a$getNNsByVector(c(4,4), 3), c(2,1,0)) #, msg="getNNsByVector check 1")
expect_equal(a$getNNsByVector(c(1,1), 3), c(0,1,2)) #, msg="getNNsByVector check 2")
expect_equal(a$getNNsByVector(c(5,3), 3), c(2,1,0)) #, msg="getNNsByVector check 3")

b <- new(AnnoyEuclidean, f)
b$load(diskfile)
expect_equal(b$getNNsByVector(c(4,4), 3), c(2,1,0)) #, msg="getNNsByVector check 1")
expect_equal(b$getNNsByVector(c(1,1), 3), c(0,1,2)) #, msg="getNNsByVector check 2")
expect_equal(b$getNNsByVector(c(5,3), 3), c(2,1,0)) #, msg="getNNsByVector check 3")

## if this is set (eg .travis.yml) then run the test
if (Sys.getenv("RunAllRcppAnnoyTests") != "yes") exit_file("Skip this test")

suppressMessages(library(RcppAnnoy))

a <- new(AnnoyAngular, 10)
a$load(system.file("tinytest", "data", "test.tree", package="RcppAnnoy"))

## This might change in the future if we change the search
## algorithm, but in that case let's update the test
checkEqual(a$getNNsByItem(0, 10), c(0, 85, 42, 11, 54, 38, 53, 66, 19, 31),
           msg="check loaded index")

a <- new(AnnoyEuclidean, 10)
v <- rnorm(10)
expect_error(a$addItem(-2, v))#, msg="check negative index", silent=TRUE)
expect_error(a$addItem(NA, v))#, msg="check NA index", silent=TRUE)

## modeled after annoy_test.py() and its t
i <- new(AnnoyAngular, 10)
i$load(system.file("tinytest", "data", "test.tree", package="RcppAnnoy"))

u <- i$getItemsVector(99)
i$save(tempfile())

v <- i$getItemsVector(99)
checkEqual(u, v, msg="getItemVector comparison")

j <- new(AnnoyAngular, 10)
j$load(system.file("tinytest", "data", "test.tree", package="RcppAnnoy"))

w <- i$getItemsVector(99)
checkEqual(u, w, msg="getItemVector comparison")

---
title: Using Annoy in package C++ code
author: 
  - name: Aaron Lun 
    affiliation: a
address:
  - code: a
    address: \url{https://github.com/LTLA}
lead_author_surname: Lun
doi: "https://cran.r-project.org/package=RcppAnnoy"
keywords:
 - Rcpp
 - Annoy
 - Approximate Nearest Neighbours
footer_contents: "RcppAnnoy Vignette"
date: \today
output: 
  pinp::pinp:
      collapse: true
      keep_tex: false
bibliography: rcppannoy.bib
skip_final_break: true
abstract: |
  This note shows how to use the Annoy library for _Approximate Nearest
  Neighbours (Oh Yeah)_ from C++ code using the headers provided by the
  RcppAnnoy package.
header-includes: >
  \newcommand{\proglang}[1]{\textsf{#1}}
  \newcommand{\pkg}[1]{\textbf{#1}}
vignette: >
  %\VignetteIndexEntry{Using Annoy in C++}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteKeywords{Rcpp, Annoy, R, Cpp, Approximate Nearest Neighbours}
  %\VignettePackage{RcppAnnoy}
  %\usepackage[utf8]{inputenc}
---

```{r, echo=FALSE, results="hide"}
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE, eval=FALSE)
```

# Setting up your package 

The [\pkg{Annoy}](https://github.com/spotify/annoy) \proglang{C++} library
\citep{Github:annoy} implements a quick and simple method for _approximate nearest neighbor
(oh yeah)_ searching.  The \pkg{RcppAnnoy} package \citep{CRAN:RcppAnnoy} provides a
centralized resource for developers to use this code in their own \proglang{R} packages by
relying on \pkg{Rcpp} \citep{TAS:Rcpp,CRAN:Rcpp}. To use \pkg{Annoy} in \proglang{C++}
code, simply put in your `DESCRIPTION` the line

```
LinkingTo: RcppAnnoy
```

and the header files will be available for inclusion into your package's source files.
Note that \pkg{Annoy} is a header-only library so no additional commands are necessary for the linker.

# Including the header files

Obviously, the header files need to be `include`d in any \proglang{C++} source file that
uses \pkg{Annoy}.  A few macros also need to be added to handle Windows-specific behaviour
and to ensure that error messages are printed through R.  Version number
comparison macros help in conditioning changes on a particular version.
Since release 0.0.17 all this is now expressed centrally in a header in the
package so users can just use this one-liner:

```{Rcpp, eval=FALSE}
#include "RcppAnnoy.h"
```

# Defining the search type 

The `AnnoyIndex` template class can accommodate different data types,
distance metrics, random number generators, and threading policies (where the
latter are a choice between sequential or multithreaded). 
Here, we will consider the most common application of a nearest-neighbor search on floating-point data with Euclidean distance.
We `typedef` the type and realized template for convenience:

```{Rcpp, eval=FALSE}
typedef float ANNOYTYPE;

typedef
Annoy::AnnoyIndex<int, ANNOYTYPE, Annoy::Euclidean, 
                  Kiss64Random,
                  RcppAnnoyIndexThreadPolicy>
MyAnnoyIndex;
```

Note that we use `float` by default, rather than the more conventional `double`.
This is chosen for speed and to be consistent with the original Python implementation.

The \pkg{Annoy} library uses random number generation during index creation
(via the `Kiss64Random` class), with a seed that is separate from R's RNG seed.
By default, the seed is fixed and results will be "deterministic" in the sense
that repeated runs on the same data will yield the same result. They will also be
unresponsive to the state of R's RNG seed. The seed used by `AnnoyIndex` can be
specified by the `set_seed` method, which should be called before adding items
to the index.

# Building an index

<!--
```{Rcpp, eval=FALSE}
// Filler for compilation.

// [[Rcpp::depends(RcppAnnoy)]]
// [[Rcpp::export(rng=false)]] 
int thingy(Rcpp::NumericMatrix mat, int c, int K, Rcpp::NumericVector Q,
           std::string indexfile = "annoy.index") {
```
-->

Let's say we have an `Rcpp::NumericMatrix` named `mat`, where each row corresponds to a sample and each column corresponds to a dimension/variable.

```{Rcpp, eval=FALSE}
const size_t nsamples=mat.nrow();
const size_t ndims=mat.ncol();
```

It is simple to build a `MyAnnoyIndex` containing the data in this matrix.
Note the copy from the double-precision matrix into a `float` vector before calling `add_item()`.

```{Rcpp, eval=FALSE}
MyAnnoyIndex obj(ndims);
// from <vector>        
std::vector<ANNOYTYPE> tmp(ndims); 
for (size_t i=0; i<nsamples; ++i) {
    Rcpp::NumericMatrix::Row cr=mat.row(i);
    // from <algorithm>
    std::copy(cr.begin(), cr.end(), tmp.begin()); 
    obj.add_item(i, tmp.data());
}
obj.build(50);
```

The `build()` method accepts an integer argument specifying the number of trees to use to
construct the index.  Indices with more trees are larger (in memory and on file) but yield
greater search accuracy.

The index can also be saved to file via

```{Rcpp, eval=FALSE}
obj.save(indexfile.c_str());
```

and reloaded in some other context:

```{Rcpp, eval=FALSE}
MyAnnoyIndex obj2(ndims);
obj2.load(indexfile.c_str()); // same as 'obj'.
```

This is helpful for parallelization across workers running in different \proglang{R}
sessions.  It also allows us to avoid rebuilding the index in applications where the same
data set is to be queried multiple times.

# Searching for nearest neighbors

Let's say that we want to find the `K` (approximate) nearest neighbors of sample `c` in
the original data set used to construct `obj`.  To do this, we write:

```{Rcpp, eval=FALSE}
std::vector<int> neighbor_index;
std::vector<ANNOYTYPE> neighbor_dist;
obj.get_nns_by_item(c, K + 1, -1, &neighbor_index,
                    &neighbor_dist); 
```

Upon return, the `neighbor_index` vector will be filled with the sample numbers of the `K`
nearest neighbors (i.e., rows of the original `mat`, in this case).  The `neighbor_dist`
vector will be filled with the distances to each of those neighbors.  Note that:

- We ask for the `K+1` nearest neighbors, as the set returned in `neighbor_index` will
usually include `c` itself.  This should be taken into consideration when the results are
used in downstream calculations.
- The returned neighbors are sorted by increasing distance from `c`.  However, note that
`c` itself may not necessarily be at the start if there is another point with the same
coordinates.
- `get_nns_by_item()` requires pointers to the vectors rather than the vectors themselves.
If the pointer to the output vector for distances is `NULL`, distances will not be
returned.  This provides a slight performance boost when only the identities of the
neighbors are of interest.
- The `-1` is the default value for a tuning parameter that specifies how many samples
should be collected from the trees for exhaustive distance calculations.  This defaults to
the number of trees multiplied by the number of requested neighbors; larger values will
increase accuracy at the cost of speed.

Another application is to query the index for the neighbors of a new sample given its
coordinates.  Assuming we have a `float*` to an array of coordinates of length `ndims`, we
do:

<!--
```{Rcpp, eval=FALSE}
// Filler for compilation.
std::vector<ANNOYTYPE> QUERY(Q.begin(), Q.end());
ANNOYTYPE* query = QUERY.data();
```
-->

```{Rcpp, eval=FALSE}
obj.get_nns_by_vector(query, K+1, -1, 
                      &neighbor_index,
                      &neighbor_dist);                                    
```

<!--
```{Rcpp, eval=FALSE}
// Closing the function.
return 1;
}
```
-->

# Further information

The [Annoy repository](https://github.com/spotify/Annoy) is the canonical source of all
things Annoying.  Questions or issues related to the \pkg{Annoy} \proglang{C++} library
itself should be posted there.  Any issues specific to the \pkg{RcppAnnoy} interface
should be posted at its separate [Github](https://github.com/eddelbuettel/rcppannoy)
repository.  An example of using the Annoy library via \pkg{RcppAnnoy} is available in the
[\pkg{BiocNeighbors}](https://bioconductor.org/packages/BiocNeighbors) package
\citep{Bioc:BiocNeighbors}.

<!--
Sanity check for compilable and runnable code.

```{Rcpp, eval=exists("RcppAnnoy.vignette.check"), ref.label=knitr::all_rcpp_labels(), include=FALSE}
```

```{r, eval=exists("RcppAnnoy.vignette.check")}
mat <- matrix(runif(1000), 100)
Q <- matrix(runif(100), 10)
thingy(mat, 1, 10, Q)
```
-->

---
title: Using Annoy in package C++ code
author: 
  - name: Aaron Lun 
    affiliation: a
address:
  - code: a
    address: \url{https://github.com/LTLA}
lead_author_surname: Lun
doi: "https://cran.r-project.org/package=RcppAnnoy"
keywords:
 - Rcpp
 - Annoy
 - Approximate Nearest Neighbours
footer_contents: "RcppAnnoy Vignette"
date: \today
output: 
  pinp::pinp:
      collapse: true
      keep_tex: false
bibliography: rcppannoy.bib
skip_final_break: true
abstract: |
  This note shows how to use the Annoy library for _Approximate Nearest
  Neighbours (Oh Yeah)_ from C++ code using the headers provided by the
  RcppAnnoy package.
header-includes: >
  \newcommand{\proglang}[1]{\textsf{#1}}
  \newcommand{\pkg}[1]{\textbf{#1}}
vignette: >
  %\VignetteIndexEntry{Using Annoy in C++}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteKeywords{Rcpp, Annoy, R, Cpp, Approximate Nearest Neighbours}
  %\VignettePackage{Rcpp}
  %\usepackage[utf8]{inputenc}
---

```{r, echo=FALSE, results="hide"}
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE, eval=FALSE)
```

# Setting up your package 

The [\pkg{Annoy}](https://github.com/spotify/annoy) \proglang{C++} library
\citep{Github:annoy} implements a quick and simple method for _approximate nearest neighbor
(oh yeah)_ searching.  The \pkg{RcppAnnoy} package \citep{CRAN:RcppAnnoy} provides a
centralized resource for developers to use this code in their own \proglang{R} packages by
relying on \pkg{Rcpp} \citep{TAS:Rcpp,CRAN:Rcpp}. To use \pkg{Annoy} in \proglang{C++}
code, simply put in your `DESCRIPTION` the line

```
LinkingTo: RcppAnnoy
```

and the header files will be available for inclusion into your package's source files.
Note that \pkg{Annoy} is a header-only library so no additional commands are necessary for the linker.

# Including the header files

Obviously, the header files need to be `include`d in any \proglang{C++} source file that
uses \pkg{Annoy}.  A few macros also need to be added to handle Windows-specific behaviour
and to ensure that error messages are printed through R.  Version number
comparison macros help in conditioning changes on a particular version.
Since release 0.0.17 all this is now expressed centrally in a header in the
package so users can just use this one-liner:

```{Rcpp, eval=FALSE}
#include "RcppAnnoy.h"
```

# Defining the search type 

The `AnnoyIndex` template class can accommodate different data types,
distance metrics, random number generators, and threading policies (where the
latter are a choice between sequential or multithreaded). 
Here, we will consider the most common application of a nearest-neighbor search on floating-point data with Euclidean distance.
We `typedef` the type and realized template for convenience:

```{Rcpp, eval=FALSE}
typedef float ANNOYTYPE;

typedef
AnnoyIndex<int, ANNOYTYPE, Euclidean, Kiss64Random,
           RcppAnnoyIndexThreadPolicy>
MyAnnoyIndex;
```

Note that we use `float` by default, rather than the more conventional `double`.
This is chosen for speed and to be consistent with the original Python implementation.

The \pkg{Annoy} library uses random number generation during index creation
(via the `Kiss64Random` class), with a seed that is separate from R's RNG seed.
By default, the seed is fixed and results will be "deterministic" in the sense
that repeated runs on the same data will yield the same result. They will also be
unresponsive to the state of R's RNG seed. The seed used by `AnnoyIndex` can be
specified by the `set_seed` method, which should be called before adding items
to the index.

# Building an index

<!--
```{Rcpp, eval=FALSE}
// Filler for compilation.

// [[Rcpp::depends(RcppAnnoy)]]
// [[Rcpp::export(rng=false)]] 
int thingy(Rcpp::NumericMatrix mat, int c, int K, Rcpp::NumericVector Q,
           std::string indexfile = "annoy.index") {
```
-->

Let's say we have an `Rcpp::NumericMatrix` named `mat`, where each row corresponds to a sample and each column corresponds to a dimension/variable.

```{Rcpp, eval=FALSE}
const size_t nsamples=mat.nrow();
const size_t ndims=mat.ncol();
```

It is simple to build a `MyAnnoyIndex` containing the data in this matrix.
Note the copy from the double-precision matrix into a `float` vector before calling `add_item()`.

```{Rcpp, eval=FALSE}
MyAnnoyIndex obj(ndims);
// from <vector>        
std::vector<ANNOYTYPE> tmp(ndims); 
for (size_t i=0; i<nsamples; ++i) {
    Rcpp::NumericMatrix::Row cr=mat.row(i);
    // from <algorithm>
    std::copy(cr.begin(), cr.end(), tmp.begin()); 
    obj.add_item(i, tmp.data());
}
obj.build(50);
```

The `build()` method accepts an integer argument specifying the number of trees to use to
construct the index.  Indices with more trees are larger (in memory and on file) but yield
greater search accuracy.

The index can also be saved to file via

```{Rcpp, eval=FALSE}
obj.save(indexfile.c_str());
```

and reloaded in some other context:

```{Rcpp, eval=FALSE}
MyAnnoyIndex obj2(ndims);
obj2.load(indexfile.c_str()); // same as 'obj'.
```

This is helpful for parallelization across workers running in different \proglang{R}
sessions.  It also allows us to avoid rebuilding the index in applications where the same
data set is to be queried multiple times.

# Searching for nearest neighbors

Let's say that we want to find the `K` (approximate) nearest neighbors of sample `c` in
the original data set used to construct `obj`.  To do this, we write:

```{Rcpp, eval=FALSE}
std::vector<int> neighbor_index;
std::vector<ANNOYTYPE> neighbor_dist;
obj.get_nns_by_item(c, K + 1, -1, &neighbor_index,
                    &neighbor_dist); 
```

Upon return, the `neighbor_index` vector will be filled with the sample numbers of the `K`
nearest neighbors (i.e., rows of the original `mat`, in this case).  The `neighbor_dist`
vector will be filled with the distances to each of those neighbors.  Note that:

- We ask for the `K+1` nearest neighbors, as the set returned in `neighbor_index` will
usually include `c` itself.  This should be taken into consideration when the results are
used in downstream calculations.
- The returned neighbors are sorted by increasing distance from `c`.  However, note that
`c` itself may not necessarily be at the start if there is another point with the same
coordinates.
- `get_nns_by_item()` requires pointers to the vectors rather than the vectors themselves.
If the pointer to the output vector for distances is `NULL`, distances will not be
returned.  This provides a slight performance boost when only the identities of the
neighbors are of interest.
- The `-1` is the default value for a tuning parameter that specifies how many samples
should be collected from the trees for exhaustive distance calculations.  This defaults to
the number of trees multiplied by the number of requested neighbors; larger values will
increase accuracy at the cost of speed.

Another application is to query the index for the neighbors of a new sample given its
coordinates.  Assuming we have a `float*` to an array of coordinates of length `ndims`, we
do:

<!--
```{Rcpp, eval=FALSE}
// Filler for compilation.
std::vector<ANNOYTYPE> QUERY(Q.begin(), Q.end());
ANNOYTYPE* query = QUERY.data();
```
-->

```{Rcpp, eval=FALSE}
obj.get_nns_by_vector(query, K+1, -1, 
                      &neighbor_index,
                      &neighbor_dist);                                    
```

<!--
```{Rcpp, eval=FALSE}
// Closing the function.
return 1;
}
```
-->

# Further information

The [Annoy repository](https://github.com/spotify/Annoy) is the canonical source of all
things Annoying.  Questions or issues related to the \pkg{Annoy} \proglang{C++} library
itself should be posted there.  Any issues specific to the \pkg{RcppAnnoy} interface
should be posted at its separate [Github](https://github.com/eddelbuettel/rcppannoy)
repository.  An example of using the Annoy library via \pkg{RcppAnnoy} is available in the
[\pkg{BiocNeighbors}](https://bioconductor.org/packages/BiocNeighbors) package
\citep{Bioc:BiocNeighbors}.

<!--
Sanity check for compilable and runnable code.

```{Rcpp, eval=exists("RcppAnnoy.vignette.check"), ref.label=knitr::all_rcpp_labels(), include=FALSE}
```

```{r, eval=exists("RcppAnnoy.vignette.check")}
mat <- matrix(runif(1000), 100)
Q <- matrix(runif(100), 10)
thingy(mat, 1, 10, Q)
```
-->

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{getArchictectureStatus}
\alias{getArchictectureStatus}
\title{Report CPU Architecture and Compiler}
\usage{
getArchictectureStatus()
}
\value{
A constant direct created at compile-time describing
the extent of AVX instructions (512 bit, 128 bit, or none)
and compiler use where currently recognised are MSC (unlikely
for R), GCC, Clang, or \sQuote{other}.
}
\description{
Report CPU Architecture and Compiler
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/version.R
\name{getAnnoyVersion}
\alias{getAnnoyVersion}
\title{Get the Annoy library version}
\usage{
getAnnoyVersion(compact = FALSE)
}
\arguments{
\item{compact}{Logical scalar indicating whether a compact
\code{\link{package_version}} should be returned.}
}
\value{
An integer vector containing the major, minor and patch version numbers;
or if \code{compact=TRUE}, a \code{\link{package_version}} object.
}
\description{
Get the version of the Annoy C++ library that RcppAnnoy was compiled with.
}
\author{
Aaron Lun
}

\name{RcppAnnoy-package}
\alias{RcppAnnoy-package}
\alias{RcppAnnoy}
\alias{Rcpp_Annoy}
\docType{package}
\title{
  Rcpp bindings for the Annoy C++ library for approximate nearest neighbors.
}
\description{
  Annoy is a small library written to provide fast and memory-efficient
  nearest neigbor lookup from a possibly static index which can be
  shared across processes.
}
\details{
  Details about Annoy are available at the reference listed below.
}
\author{
  Dirk Eddelbuettel for the R interface; Erik Bernhardsson for Annoy itself.

  Maintainer: Dirk Eddelbuettel <edd@debian.org>
}
\references{
  \url{https://github.com/spotify/annoy}
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoy.R
\name{AnnoyIndex}
\alias{AnnoyIndex}
\alias{AnnoyEuclidean}
\alias{Rcpp_AnnoyEuclidean-class}
\alias{Rcpp_AnnoyEuclidean}
\alias{AnnoyAngular}
\alias{Rcpp_AnnoyAngular-class}
\alias{Rcpp_AnnoyAngular}
\alias{AnnoyManhattan}
\alias{Rcpp_AnnoyManhattan-class}
\alias{Rcpp_AnnoyManhattan}
\alias{AnnoyHamming}
\alias{Rcpp_AnnoyHamming-class}
\alias{Rcpp_AnnoyHamming}
\alias{AnnoyDotProduct}
\alias{Rcpp_AnnoyDotProduct-class}
\alias{Rcpp_AnnoyDotProduct}
\title{Approximate Nearest Neighbors with Annoy}
\description{
Annoy is a small library written to provide fast and memory-efficient
nearest neighbor lookup from a possibly static index which can be
shared across processes.
}
\section{Usage}{

\preformatted{
a <- new(AnnoyEuclidean, vectorsz)

a$setSeed(0)
a$setVerbose(0)

a$addItem(i, dv)

a$getNItems()

a$getItemsVector(i)
a$getDistance(i, j)

a$build(n_trees)

a$getNNsByItem(i, n)
a$getNNsByItemList(i, n, search_k, include_distances)

a$getNNsByVector(v, n)
a$getNNsByVectorList(v, n, search_k, include_distances)

a$save(fn)
a$load(fn)
a$unload()
}
}

\section{Details}{


\code{new(Class, vectorsz)}
Create a new Annoy instance of type \code{Class} where \code{Class}
is on of the following:
\code{AnnoyEuclidean},
\code{AnnoyAngular},
\code{AnnoyManhattan},
\code{AnnoyHamming}.
\code{vectorsz} denotes the length of the vectors that the Annoy instance
will be indexing.

\code{$addItem(i, v)}
Adds item \code{i} (any nonnegative integer) with vector \code{v}.
Note that it will allocate memory for \code{max(i) + 1} items.

\code{$build(n_trees)}
Builds a forest of \code{n_trees} trees.
More trees gives higher precision when querying.
After calling \code{build}, no more items can be added.

\code{$save(fn)}
Saves the index to disk as filename \code{fn}.
After saving, no more items can be added.

\code{$load(fn)}
Loads (mmaps) an index from filename \code{fn} on disk.

\code{$unload()}
Unloads index.

\code{$getDistance(i, j)}
Returns the distance between items \code{i} and \code{j}

\code{$getNNsByItem(i, n)}
Returns the \code{n} closest items as an integer vector of indices.

\code{$getNNsByVector(v, n)}
Same as \code{$getNNsByItem}, but queries by vector \code{v} rather than
index \code{i}.

\code{$getNNsByItemList(i, n, search_k = -1, include_distances = FALSE)}
Returns the n closest items to item \code{i} as a list.
During the query it will inspect up to \code{search_k} nodes which
defaults to \code{n_trees * n} if not provided.
\code{search_k} gives you a run-time tradeoff between better accuracy and
speed.
If you set \code{include_distances} to \code{TRUE},
it will return a length 2 list with elements \code{"item"} &
\code{"distance"}.
The \code{"item"} element contains the \code{n} closest items as an integer
vector of indices.
The optional \code{"distance"} element contains the corresponding distances
to \code{"item"} as a numeric vector.

\code{$getNNsByVectorList(i, n, search_k = -1, include_distances = FALSE)}
Same as \code{$getNNsByItemList}, but queries by vector \code{v} rather than
index \code{i}

\code{$getItemsVector(i)}
Returns the vector for item \code{i} that was previously added.

\code{$getNItems()}
Returns the number of items in the index.

\code{$setVerbose()}
If \code{1} then messages will be printed during processing.
If \code{0} then messages will be suppressed during processing.

\code{$setSeed()}
Set random seed for annoy (integer).
}

\examples{
library(RcppAnnoy)

# BUILDING ANNOY INDEX ---------------------------------------------------------
vector_size <- 10
a <- new(AnnoyEuclidean, vector_size)

a$setSeed(42)

# Turn on verbose status messages (0 to turn off)
a$setVerbose(1)

# Load 100 random vectors into index
for (i in 1:100) a$addItem(i - 1, runif(vector_size)) # Annoy uses zero indexing

# Display number of items in index
a$getNItems()

# Retrieve item at postition 0 in index
a$getItemsVector(0)

# Calculate distance between items at postitions 0 & 1 in index
a$getDistance(0, 1)

# Build forest with 50 trees
a$build(50)


# PERFORMING ANNOY SEARCH ------------------------------------------------------

# Retrieve 5 nearest neighbors to item 0
# Returned as integer vector of indices
a$getNNsByItem(0, 5)

# Retrieve 5 nearest neighbors to item 0
# search_k = -1 will invoke default search_k value of n_trees * n
# Return results as list with an element for distance
a$getNNsByItemList(0, 5, -1, TRUE)

# Retrieve 5 nearest neighbors to item 0
# search_k = -1 will invoke default search_k value of n_trees * n
# Return results as list without an element for distance
a$getNNsByItemList(0, 5, -1, FALSE)


v <- runif(vector_size)
# Retrieve 5 nearest neighbors to vector v
# Returned as integer vector of indices
a$getNNsByVector(v, 5)

# Retrieve 5 nearest neighbors to vector v
# search_k = -1 will invoke default search_k value of n_trees * n
# Return results as list with an element for distance
a$getNNsByVectorList(v, 5, -1, TRUE)

# SAVING/LOADING ANNOY INDEX ---------------------------------------------------

# Create a tempfile, replace with a local file to keep
treefile <- tempfile(pattern="annoy", fileext=".tree")

# Save annoy tree to disk
a$save(treefile)

# Load annoy tree from disk
a$load(treefile)

# Unload index from memory
a$unload()
}
